/* mac061997,98 by HNS/DSITRI hns@computer.org
** socket.h
**
** 02.01.1998	HNS		shutdown() added
*/

#pragma once

#include "netinet/in.h"

/* socket types */

#define SOCK_DGRAM	0
#define SOCK_STREAM 1
#define SOCK_RAW	2

/* socket levels for get/setsockopt() */

#define SOL_SOCKET	7

/* socket level options for get/setsockopt() */

#define SO_SNDBUF		0
#define SO_RCVBUF		1
#define SO_SNDLOWAT		2
#define SO_RCVLOWAT		3
#define SO_SNDTIMEO		4
#define SO_RCV			5
#define SO_ERROR		6
#define SO_TYPE			7
#define SO_PROTOTYPE	8
#define SO_LINGER		9
#define SO_DEBUG		10
#define SO_REUSEADDR	11
#define SO_KEEPALIVE	12
#define SO_DONTROUTE	13
#define SO_BROADCAST	14
#define SO_OOBINLINE	15


struct linger
  {
  int l_onoff;	/* on/off */
  int l_linger;	/* time */
  };

/* message options for send(), recv() */

#define MSG_OOB			1
#define MSG_PEEK		2
#define MSG_DONTROUTE	4

/* address families */

#define AF_INET			2
#define AF_APPLETALK	16

/* protocol families */

#define PF_INET	AF_INET
#define PF_APPLETALK AF_APPLETALK

/* internet protocol numbers as defined in RFC1340 */

#define P_INET_TCP	6
#define P_INET_UDP	17
#define P_INET_IP	4
#define P_INET_ICMP 1

struct sockaddr
	{
	unsigned short sa_family;
	char sa_data[16-sizeof(unsigned short)];	/* fill up to 16 bytes */
	};

/* Funktionsheader */

int accept(int s, struct sockaddr *peer, int *peerlen);
int bind(int s, struct sockaddr *addr, int addrlen);
int connect(int s, struct sockaddr *peer, int peerlen);
int getsockname(int s, struct sockaddr *addr, int *addrlen);
int getpeername(int s, struct sockaddr *addr, int *addrlen);
int getsockopt(int s, int level, int opt, void *arg, int *arglen);
int setsockopt(int s, int level, int opt, void *arg, int arglen);
int listen(int s, int queuelen);
int recv(int s, void *bfr, int len, int flags);
int recvfrom(int s, void *bfr, int len, int flags, struct sockaddr *from, int *addrlen);
int send(int s, void *bfr, int len, int flags);
int sendto(int s, void *bfr, int len, int flags, struct sockaddr *addr, int addrlen);
int shutdown(int fd, int what);
int socket(int family, int type, int proto);

/* EOF */